/* Warning:  stdio.h *must* be include before my_types.h if this file is
	     also included.  This file needs symbols defined in stdio.h,
	     but if it were to explicitly include stdio.h,  FILENAME_MAX
	     would be redefined in some cases. */
#ifndef LIBUTILS_INCLUDED
#define LIBUTILS_INCLUDED
#include "patchlevel.h"
#include "my_types.h"

typedef struct {
    FILE *fp;
    int bytesleft;
} MY_FILE;

typedef struct {
    fpos_t pos;
    int bytesleft;
} my_fpos_t;

extern struct lib_file_entry {
    long offset;
    char name[13];
} *lib_files;
extern int lib_filecnt;
extern int directory_mode;
extern int prog_index;

BOOLEAN init_lib();
MY_FILE *find_file();
MY_FILE *reopen_prog();
void rewind_program();
int my_fgetc();
char *my_fgets();
int my_read();
int my_fgetpos();
int my_fsetpos();
int my_read();
void my_fclose();
#define my_getc(fp_) (directory_mode ? \
			(getc((fp_)->fp)) : \
			(((fp_)->bytesleft-->0)?getc((fp_)->fp):-1))
#define my_ungetc(c,fp_) (directory_mode ? \
			(((c)==-1)?(c):ungetc((c),(fp_)->fp)) : \
			(((c)==-1)?(((fp_)->bytesleft=0),-1) : \
				   ((fp_)->bytesleft++,ungetc((c),(fp_)->fp))))
#endif
