.TH XVIEWGL 1L "12th Mar 1991"
.SH NAME
xviewgl \- display GRASP library files under X11
.SH SYNTAX
.B xviewgl
[\fB-d \fIdel\fR] [\fB-f\fR] [\fB-F\fR] [\fB-i\fR] [\fB-s\fR] [\fB-t\fR]
[\fB-x \fIn\fR] [\fB-y \fIn\fR] \fIfil\fRe [\fIscript\fR]

Where
.I file
is either the name of a directory containing an unpacked
GRASP library, the name of a GRASP library file ending
in ".gl", or the name of a GRASP script ending in ".txt".  If
.I file
is a directory or GRASP library name, you may specify
.I script
, the name of a script to use within the library or directory.  The
default is to use the first script encountered.

.SH DESCRIPTION
.I Xgl
is an X11-based viewer for
.I GRASP
libraries.
.I GRASP
is an animation package
popular on
.I IBM PCs.
It is a near-complete implementation of
.I GRASP V1.10
, with many features from later versions of
.I GRASP.

In order to see the colors properly, you may need to set input focus to
.IB xviewgl\c
's main window.  If that fails you will need to install the color map
using the \-i option.  The
.IB xviewgl
window will accept the following input in addition to any requested by
GRASP files:  <space> will pause the animation, <esc> will exit
.IB xviewgl
, and any other key will break out of a single delay.

.SH OPTIONS
.nf
\-d \fIdel\fR
	Sets minimum delay to \fIdel\fR hundredths of a second.  This
	option is useful for viewing files designed for viewing on slow
	PCs.

\-F	Attempts to play friendly with the colormap.  Colors
	are allocated from the highest number down so as to
	minimize the diruption of other applications' colors.

\-f	Attempts to "fix up" the aspect ratio according to the
	screen type.

\-i	Install colormap.

\-q     Quiet mode.  Don't beep for sound effects.

\-s	Synchronize display.  For debugging.

\-t	Trace.  Display each line before executing.

\-x \fIn\fR	These options allow you to specify x and y scaling factors.
\-y \fIn\fR	Only integer values are allowed.
.fi

.SH KNOWN BUGS

Monochrome support is latent, but I don't have a monochrome system, so I can't
get it working.  Feel free to hack around in windows.c to try to get it going.

I am looking for information on .DFF and BSAVE images.  Any help or
specifications may lead to my adding support for them.

I am also interested in adding support for any of the standard variables
GRASP supports, and for info on commands (like DLOAD and PUTDFF) which I
don't understand.  Any documentation or command descriptions would be
helpful.  (I have seen the GRASP v1.10 docs, so I don't need them...)

.SH AUTHOR
Brad Daniels
.I <daniels@bigred.enet.dec.com>
